package org.dromara.system.service.impl;

import cn.hutool.core.util.ObjUtil;
import org.dromara.common.core.exception.ServiceException;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.SysRecipeCategoryBo;
import org.dromara.system.domain.vo.SysRecipeCategoryVo;
import org.dromara.system.domain.SysRecipeCategory;
import org.dromara.system.mapper.SysRecipeCategoryMapper;
import org.dromara.system.service.ISysRecipeCategoryService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 食谱分类管理Service业务层处理
 *
 * @author Lion Li
 * @date 2025-07-01
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class SysRecipeCategoryServiceImpl implements ISysRecipeCategoryService {

    private final SysRecipeCategoryMapper baseMapper;

    /**
     * 查询食谱分类管理
     *
     * @param recipeCategoryId 主键
     * @return 食谱分类管理
     */
    @Override
    public SysRecipeCategoryVo queryById(Long recipeCategoryId) {
        return baseMapper.selectVoById(recipeCategoryId);
    }

    /**
     * 分页查询食谱分类管理列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 食谱分类管理分页列表
     */
    @Override
    public TableDataInfo<SysRecipeCategoryVo> queryPageList(SysRecipeCategoryBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<SysRecipeCategory> lqw = buildQueryWrapper(bo);
        Page<SysRecipeCategoryVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的食谱分类管理列表
     *
     * @param bo 查询条件
     * @return 食谱分类管理列表
     */
    @Override
    public List<SysRecipeCategoryVo> queryList(SysRecipeCategoryBo bo) {
        LambdaQueryWrapper<SysRecipeCategory> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<SysRecipeCategory> buildQueryWrapper(SysRecipeCategoryBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<SysRecipeCategory> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(SysRecipeCategory::getRecipeCategoryId);
        lqw.like(StringUtils.isNotBlank(bo.getName()), SysRecipeCategory::getName, bo.getName());
        lqw.eq(bo.getSort() != null, SysRecipeCategory::getSort, bo.getSort());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), SysRecipeCategory::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增食谱分类管理
     *
     * @param bo 食谱分类管理
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(SysRecipeCategoryBo bo) {
        SysRecipeCategory add = MapstructUtils.convert(bo, SysRecipeCategory.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setRecipeCategoryId(add.getRecipeCategoryId());
        }
        return flag;
    }

    /**
     * 修改食谱分类管理
     *
     * @param bo 食谱分类管理
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(SysRecipeCategoryBo bo) {
        SysRecipeCategory update = MapstructUtils.convert(bo, SysRecipeCategory.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(SysRecipeCategory entity) {
        if (ObjUtil.isNull(entity.getRecipeCategoryId())) {
            long cnt = baseMapper.selectCount(Wrappers.lambdaQuery(SysRecipeCategory.class)
                .eq(SysRecipeCategory::getName, entity.getName()));
            if (cnt > 0) {
                throw new ServiceException("食材名称已经存在!");
            }
        } else {
            //TODO 做一些数据校验,如唯一约束
        }
    }

    /**
     * 校验并批量删除食谱分类管理信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
